#ifndef FORKIT_H
#define FORKIT_H

#ifndef OS2
#include <sys/poll.h>
#endif

#include "port.h"

class Fork;

typedef void *PVOID;

typedef void(* FUNCTION)(Fork *, PVOID);

typedef struct
{
  FILE_TYPE child_read, child_write;
  Fork *f;
  PVOID param;
  FUNCTION func;
} THREAD_DATA;

class Fork
{
public:
  Fork();
  void go(FUNCTION func, PVOID param, int num);


  int Read(PVOID buf, int size, int timeout = 60);
  int Write(PVOID buf, int size);

  void startit(THREAD_DATA *td); // free td when finished

private:
#ifndef OS2
  pollfd m_poll;
#endif
  FILE_TYPE m_read;
  FILE_TYPE m_write;
};

#endif

